/*
 * Hilfsfunktionen zum Debuggen
 *
 *
 * 2014-09-13 Nicolas
 *
 */


#ifndef DEBUGHELP_H
	#define DEBUGHELP_H

	#include "hardwareconfig.h"
	#include "stm32f10x_gpio.h"

	/* Aufzeichen von Funktionsaufrufen (evtl. mit Parametern) */

	// Moegliche Funktionsaufrufe
	typedef enum {
	   fnix,
	   f_usbdev_init,
	   f_usbdev_reset,
	   f_usbdev_setConfiguration,
	   f_usbdev_setDeviceAddress,
	   f_usbdev_status_In,
	   f_usbdev_status_Out,
	   f_usbdev_data_Setup,
	   f_usbdev_noData_Setup,
	   f_usbdev_get_Interface_Setting,
	   f_usbdev_getDeviceDescriptor,
	   f_usbdev_getConfigDescriptor,
	   f_usbdev_GetStringDescriptor,
	   f_usbdev_setProtocol,
	   f_usbdev_getProtocolValue,
	   f_usbdev_getReportDescriptor,
	   f_usbdev_getHIDDescriptor,
	   fGetIdle,
	   fSetReport,
	} logfcn_e;

	// Einzelner Aufruf mit Parameter
	typedef struct{
		logfcn_e fcn;
		uint16_t value;
		} logitem_t;

	// Alle Aufrufe
	typedef struct {
		logitem_t item[256];
		uint8_t cnt;
	} log_t;

	// Globale Variable definiert in main.c
	log_t log;

	/* sammelt die letzten 255 Aufrufe ein. Aufruf:
	 * logit(funktionsname,parameter);  */
	static inline void logit(logfcn_e a, uint16_t val)
	{
		#ifdef DEBUG
			log.item[log.cnt].fcn = a;
			log.item[log.cnt].value = val;
			log.cnt++;
		#endif
	}

	/* Fehler: Setzt Fehler-LED und Schluss */
	static inline void error(void)
	{
		GPIO_SetBits(ERROR_LED_GPIO,ERROR_LED_Pin);
		while(1);
	}

	/* Toggelt Pin SPARE1 */
	static inline void togglespare1(void)
	{
		if(GPIO_ReadInputDataBit(SPARE1_GPIO,SPARE1_Pin)) {
			GPIO_ResetBits(SPARE1_GPIO,SPARE1_Pin);
		}
		else {
			GPIO_SetBits(SPARE1_GPIO,SPARE1_Pin);
		}
	}


#endif
