/*
 * hardwareconfig.h
 *
 * Hardware-Config (Nachfolger der "ioMapping.h")
 *
 * "STM32 minimal development board" mit STM32C8T6 und USB-Anschluss
 *
 * 2014-09-13 Nicolas
 */



#ifndef HARDWARE_CONFIG_H
	#define HARDWARE_CONFIG_H


	#include "stm32f10x.h"

	/*Unique Devices IDs register set STM32F1x */
	#define         ID1          (0x1FFFF7E8)
	#define         ID2          (0x1FFFF7EC)
	#define         ID3          (0x1FFFF7F0)



	/* GPIO RCC Registers */
	#define RCC_APB2Periph_ALLGPIO   (RCC_APB2Periph_GPIOA \
									| RCC_APB2Periph_GPIOB \
									| RCC_APB2Periph_GPIOC )


/* Solange die Pin-Definitionen nicht gesetzt wird, wird der USB-Pull-Up
 * nicht genutzt */
/*
	#define USB_PULLUP_GPIO                  GPIOB
	#define USB_PULLUP_Pin                   GPIO_Pin_14
	#define USB_PULLUP_GPIO_CLK              RCC_APB2Periph_GPIOB
*/

	#define ERROR_LED_Pin                    GPIO_Pin_0
	#define ERROR_LED_GPIO                   GPIOB
	#define ERROR_LED_GPIO_CLK               RCC_APB2Periph_GPIOB

	#define KEYBOARD_LED_CAPSLOCK_Pin        GPIO_Pin_1
	#define KEYBOARD_LED_CAPSLOCK_GPIO       GPIOB
	#define KEYBOARD_LED_CAPSLOCK_GPIOCLK    RCC_APB2Periph_GPIOB

	#define KEYBOARD_LED_NUMLOCK_Pin         GPIO_Pin_5
	#define KEYBOARD_LED_NUMLOCK_GPIO        GPIOB
	#define KEYBOARD_LED_NUMLOCK_GPIOCLK     RCC_APB2Periph_GPIOB

	#define KEYBOARD_LED_SCRLLOCK_Pin        GPIO_Pin_6
	#define KEYBOARD_LED_SCRLLOCK_GPIO       GPIOB
	#define KEYBOARD_LED_SCRLLOCK_GPIOCLK    RCC_APB2Periph_GPIOB

	#define SPARE1_GPIO                      GPIOB
	#define SPARE1_Pin                       GPIO_Pin_7

	// Belegt:
    // PA11, PA12, PA13, PA14, PA15
    // PB0, PB1, PB2, PB3, PB4, PB5, PB8 (SPARE1), PB14
    // (PC15, PC14)


#endif



