/*
 * keyboard_usb_desc.h
 *
 * USB-Descriptoren fuer HID-Tastatur
 *
 * Hier werden nur globale Konstanten definiert.
 *
 * 16.09.2014 Nicolas
 */



#ifndef __KEYBOARD_USB_DESC_H
	#define __KEYBOARD_USB_DESC_H

	/* Alias-Namen fuer Descriptor-Konstanten */
	#define usbdev_ConfigDescriptor   keyboard_ConfigDescriptor
	#define usbdev_DeviceDescriptor   keyboard_DeviceDescriptor
	#define usbdev_ReportDescriptor   keyboard_ReportDescriptor
	#define usbdev_StringVendor       keyboard_StringVendor
	#define usbdev_StringSerial       keyboard_StringSerial
	#define usbdev_StringProduct      keyboard_StringProduct
	#define usbdev_StringLangID       keyboard_StringLangID
	#define USBDEV_SIZ_STRING_VENDOR  KEYBOARD_SIZ_STRING_VENDOR
	#define USBDEV_SIZ_STRING_PRODUCT KEYBOARD_SIZ_STRING_PRODUCT
	#define USBDEV_SIZ_STRING_SERIAL  KEYBOARD_SIZ_STRING_SERIAL
	#define USBDEV_SIZ_STRING_LANGID  KEYBOARD_SIZ_STRING_LANGID
	#define USBDEV_SIZ_REPORT_DESC 	  KEYBOARD_SIZ_REPORT_DESC
	#define USBDEV_SIZ_CONFIG_DESC    KEYBOARD_SIZ_CONFIG_DESC
	#define USBDEV_SIZ_DEVICE_DESC    KEYBOARD_SIZ_DEVICE_DESC
	#define USBDEV_SIZ_HID_DESC       KEYBOARD_SIZ_HID_DESC
	#define USBDEV_OFF_HID_DESC       KEYBOARD_OFF_HID_DESC


	/* Hilfskonstanten fuer die Definition der Descriptoren */
	#define USB_DEVICE_DESCRIPTOR_TYPE              0x01
	#define USB_CONFIGURATION_DESCRIPTOR_TYPE       0x02
	#define USB_STRING_DESCRIPTOR_TYPE              0x03
	#define USB_INTERFACE_DESCRIPTOR_TYPE           0x04
	#define USB_ENDPOINT_DESCRIPTOR_TYPE            0x05

	#define HID_DESCRIPTOR_TYPE                     0x21 // = HID
	#define KEYBOARD_SIZ_HID_DESC                   0x09
	#define KEYBOARD_OFF_HID_DESC                   0x12

	#define KEYBOARD_SIZ_DEVICE_DESC                18
	#define KEYBOARD_SIZ_CONFIG_DESC                34
	#define KEYBOARD_SIZ_REPORT_DESC                65
	#define KEYBOARD_SIZ_STRING_LANGID              4
	#define KEYBOARD_SIZ_STRING_VENDOR              38
	#define KEYBOARD_SIZ_STRING_PRODUCT             30
	#define KEYBOARD_SIZ_STRING_SERIAL              26

	#define STANDARD_ENDPOINT_DESC_SIZE             0x09


    /* USB-Descriptoren */
	extern const uint8_t keyboard_DeviceDescriptor[KEYBOARD_SIZ_DEVICE_DESC];
	extern const uint8_t keyboard_ConfigDescriptor[KEYBOARD_SIZ_CONFIG_DESC];
	extern const uint8_t keyboard_ReportDescriptor[KEYBOARD_SIZ_REPORT_DESC];
	extern const uint8_t keyboard_StringLangID[KEYBOARD_SIZ_STRING_LANGID];
	extern const uint8_t keyboard_StringVendor[KEYBOARD_SIZ_STRING_VENDOR];
	extern const uint8_t keyboard_StringProduct[KEYBOARD_SIZ_STRING_PRODUCT];
	extern uint8_t keyboard_StringSerial[KEYBOARD_SIZ_STRING_SERIAL];

#endif


