/**
  ******************************************************************************
  * @file    usb_prop.h
  * @author  MCD Application Team
  * @version V4.0.0
  * @date    21-January-2013
  * @brief   All processing related to Joystick Mouse demo
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2013 STMicroelectronics</center></h2>
  *
  * Licensed under MCD-ST Liberty SW License Agreement V2, (the "License");
  * You may not use this file except in compliance with the License.
  * You may obtain a copy of the License at:
  *
  *        http://www.st.com/software_license_agreement_liberty_v2
  *
  * Unless required by applicable law or agreed to in writing, software 
  * distributed under the License is distributed on an "AS IS" BASIS, 
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  *
  ******************************************************************************
  */


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USB_PROP_H
#define __USB_PROP_H

/* Includes ------------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
typedef enum _HID_REQUESTS
{
  GET_REPORT = 1,
  GET_IDLE,
  GET_PROTOCOL,

  SET_REPORT = 9,
  SET_IDLE,
  SET_PROTOCOL
} HID_REQUESTS;

/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void usbdev_init(void);
void usbdev_reset(void);
void usbdev_setConfiguration(void);
void usbdev_setDeviceAddress (void);
void usbdev_status_In (void);
void usbdev_status_Out (void);
RESULT usbdev_data_Setup(uint8_t);
RESULT usbdev_noData_Setup(uint8_t);
RESULT usbdev_Get_Interface_Setting(uint8_t Interface, uint8_t AlternateSetting);
uint8_t *usbdev_getDeviceDescriptor(uint16_t );
uint8_t *usbdev_getConfigDescriptor(uint16_t);
uint8_t *usbdev_getStringDescriptor(uint16_t);
RESULT usbdev_setProtocol(void);
uint8_t *usbdev_getProtocolValue(uint16_t Length);
RESULT usbdev_setProtocol(void);
uint8_t *usbdev_getReportDescriptor(uint16_t Length);
uint8_t *usbdev_getHIDDescriptor(uint16_t Length);
uint8_t *usbdev_setReportFeature(uint16_t Length);

/* Exported define -----------------------------------------------------------*/
#define usbdev_getConfiguration          NOP_Process
//#define usbdev_setConfiguration          NOP_Process
#define usbdev_getInterface              NOP_Process
#define usbdev_setInterface              NOP_Process
#define usbdev_getStatus                 NOP_Process
#define usbdev_clearFeature              NOP_Process
#define usbdev_setEndPointFeature        NOP_Process
#define usbdev_setDeviceFeature          NOP_Process
//#define usbdev_setDeviceAddress          NOP_Process

#define REPORT_DESCRIPTOR                  0x22

#endif /* __USB_PROP_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
